unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ImgList, StdCtrls, ExtCtrls, Menus, ComCtrls;

type
  TForm1 = class(TForm)
    ListFolder: TListBox;
    ImageList: TImageList;
    ListFile: TListBox;
    Splitter2: TSplitter;
    Splitter1: TSplitter;
    MainMenu: TMainMenu;
    MenuFolder: TMenuItem;
    MenuEnterFolder: TMenuItem;
    MenuLeaveFolder: TMenuItem;
    MenuTrashFolder: TMenuItem;
    MenuHelp: TMenuItem;
    MenuVersion: TMenuItem;
    Status: TStatusBar;
    File1: TMenuItem;
    MenuTrashFile: TMenuItem;
    Panel1: TPanel;
    PaintBox: TPaintBox;
    MenuRight: TMenuItem;
    MenuLeft: TMenuItem;
    MenuExecute: TMenuItem;
    MenuFullView: TMenuItem;
    procedure ListFolderDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ListFolderClick(Sender: TObject);
    procedure PaintBoxPaint(Sender: TObject);
    procedure ListFileClick(Sender: TObject);
    procedure MenuEnterFolderClick(Sender: TObject);
    procedure MenuLeaveFolderClick(Sender: TObject);
    procedure MenuTrashFolderClick(Sender: TObject);
    procedure ListFolderEnter(Sender: TObject);
    procedure ListFolderExit(Sender: TObject);
    procedure MenuVersionClick(Sender: TObject);
    procedure ListFileDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure ListFileEnter(Sender: TObject);
    procedure ListFileExit(Sender: TObject);
    procedure MenuTrashFileClick(Sender: TObject);
    procedure MenuRightClick(Sender: TObject);
    procedure MenuLeftClick(Sender: TObject);
    procedure MenuExecuteClick(Sender: TObject);
    procedure MenuFullViewClick(Sender: TObject);
  private
  private
    //  JgpX
    FCurrentPath: String;
    //  TutH_
    FSubFolders: TStringList;
    procedure BuildSubFolderList(const APath: String); overload;
    procedure BuildSubFolderList(); overload;
  private
    //  ItH_pX
    FSelectPath: String;
    //  tH_ACe
    FFolderItems: TStringList;
    procedure BuildFolderItemList(const APath: String); overload;
    procedure BuildFolderItemList(); overload;
    //  JgtH_ύX
    procedure SetCurrentPath(const APath: String);
    //  ItH_ύX
    procedure SetSelectPath(const APath: String);
  private
    FBitmap: TBitmap;
    //  It@CpX
    FSelectFile: String;
    //  It@CύX
    procedure SetSelectFile(const APath: String);
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

uses
    Info, ShellApi, ShlObj, GDIPOBJ, GDIPAPI, Viewer;

//-----------------------------------------------------------------------------
//  tH_ƃt@Ĉ̖݂̕o
function ExtractItemName(const APath: String): String;
begin
    Result := ExtractFileName(ExcludeTrailingPathDelimiter(APath));
end;

//-----------------------------------------------------------------------------
//  TutH_邩ǂ
function SubFolderExists(const APath: String): Boolean;
var
    LPath: String;
    LRec: TSearchRec;
    LFull: String;
begin
    Result := False;

    if (not DirectoryExists(APath)) then Exit;

    LPath := IncludeTrailingPathDelimiter(APath);
    if FindFirst(LPath + '*.*', faDirectory, LRec) = 0 then
    begin
        try
            repeat
                if (LRec.Name = '.') then Continue;
                if (LRec.Name = '..') then Continue;
                LFull := LPath + LRec.Name;
                if (DirectoryExists(LFull)) then
                begin
                    Result := True;
                    Break;
                end;
            until
                FindNext(LRec) <> 0;
        finally
            FindClose(LRec);
        end;
    end;
end;

{$R *.dfm}

//-----------------------------------------------------------------------------
//  o[W\
procedure TForm1.MenuVersionClick(Sender: TObject);
begin
    OpenInfoForm();
end;

//-----------------------------------------------------------------------------
//  wtH_̃TutH_
procedure TForm1.BuildSubFolderList(const APath: String);
var
    LPath: String;
    LRec: TSearchRec;
    LFull: String;
    LAttr: Integer;
begin
    LPath := IncludeTrailingPathDelimiter(APath);
    if FindFirst(LPath + '*.*', faAnyFile, LRec) = 0 then
    begin
        try
            repeat
                if (LRec.Name = '.') then Continue;
                if (LRec.Name = '..') then Continue;
                LFull := LPath + LRec.Name;
                if (DirectoryExists(LFull)) then
                begin
                    //  擾
                    LAttr := LRec.Attr;
                    //  `FbN
                    if ((LAttr and SysUtils.faHidden) <> 0) then Continue;
                    if ((LAttr and SysUtils.faSysFile) <> 0) then Continue;
                    //  Xgɒǉ
                    LFull := IncludeTrailingPathDelimiter(LFull);
                    //  TutH_邩ǂL^
                    FSubFolders.AddObject(LFull, TObject(Integer(SubFolderExists(LFull))));
                end;
            until
                FindNext(LRec) <> 0;
        finally
            FindClose(LRec);
        end;
    end;
end;

//-----------------------------------------------------------------------------
//  JgtH_̃TutH_񋓎s
procedure TForm1.BuildSubFolderList();
begin
    Screen.Cursor := crHourGlass;
    FSubFolders.Clear();
    BuildSubFolderList(FCurrentPath);
    Screen.Cursor := crDefault;
end;

//-----------------------------------------------------------------------------
//  wtH_̃ACe
procedure TForm1.BuildFolderItemList(const APath: String);
var
    LPath: String;
    LRec: TSearchRec;
    LFull: String;
    LAttr: Integer;
begin
    LPath := IncludeTrailingPathDelimiter(APath);
    if FindFirst(LPath + '*.*', faAnyFile, LRec) = 0 then
    begin
        try
            repeat
                if (LRec.Name = '.') then Continue;
                if (LRec.Name = '..') then Continue;
                LFull := LPath + LRec.Name;
                if (FileExists(LFull)) then
                begin
                    //  擾
                    LAttr := LRec.Attr;
                    //  `FbN
                    if ((LAttr and SysUtils.faHidden) <> 0) then Continue;
                    if ((LAttr and SysUtils.faSysFile) <> 0) then Continue;
                    //  Xgɒǉ
                    FFolderItems.Add(LFull);
                end;
            until
                FindNext(LRec) <> 0;
        finally
            FindClose(LRec);
        end;
    end;
end;

//-----------------------------------------------------------------------------
//  tH_̃ACe
procedure TForm1.BuildFolderItemList();
begin
    Screen.Cursor := crHourGlass;
    FFolderItems.Clear();
    BuildFolderItemList(FSelectPath);
    Screen.Cursor := crDefault;
end;

//-----------------------------------------------------------------------------
//  JgtH_ύX
procedure TForm1.SetCurrentPath(const APath: String);
begin
    //  L^
    FCurrentPath := IncludeTrailingPathDelimiter(APath);
    //  TutH_
    BuildSubFolderList();
    //  Xg{bNXɕ\
    ListFolder.Items.Assign(FSubFolders);
    //  0ԖڂI
    if (ListFolder.Count > 0) then
    begin
        ListFolder.ItemIndex := 0;
        //  ItH_ύX
        SetSelectPath(ListFolder.Items[ListFolder.ItemIndex]);
    end;
end;

//-----------------------------------------------------------------------------
//  ItH_ύX
procedure TForm1.SetSelectPath(const APath: String);
begin
    FSelectPath := APath;
    Self.Caption := FSelectPath;
    //  tH_ACe
    BuildFolderItemList();
    //  Xg{bNXɕ\
    ListFile.Items.Assign(FFolderItems);
    if (ListFile.Items.Count > 0) then
    begin
        ListFile.ItemIndex := 0;
        //  It@CύX
        SetSelectFile(ListFile.Items[ListFile.ItemIndex]);
    end;
end;

//-----------------------------------------------------------------------------
//  It@CύX
procedure TForm1.SetSelectFile(const APath: String);
begin
    FSelectFile := APath;
    PaintBox.Repaint();
end;

//-----------------------------------------------------------------------------
//  tH[쐬
procedure TForm1.FormCreate(Sender: TObject);
begin
    //  `prbg}bv쐬
    FBitmap := TBitmap.Create();
    FBitmap.Width := Screen.Width;
    FBitmap.Height := Screen.Height;
    PaintBox.ControlStyle := PaintBox.ControlStyle + [csOpaque];

    //  TutH_XgEACeXg쐬
    FSubFolders := TStringList.Create();
    FSubFolders.Sorted := True;
    FFolderItems := TStringList.Create();
    FFolderItems.Sorted := True;

    //  }ChLgX^[g
    SetCurrentPath(GetSpecialFolderPath(CSIDL_PERSONAL));
end;

//-----------------------------------------------------------------------------
//  tH[j
procedure TForm1.FormDestroy(Sender: TObject);
begin
    FSubFolders.Free();
    FFolderItems.Free();
    FBitmap.Free();
end;

//-----------------------------------------------------------------------------
//  tH_ꗗtH_I
procedure TForm1.ListFolderClick(Sender: TObject);
begin
    //  IĂ
    if (ListFolder.ItemIndex <> -1) then
    begin
        SetSelectPath(ListFolder.Items[ListFolder.ItemIndex]);
    end;
end;

//-----------------------------------------------------------------------------
//  t@Cꗗt@CI
procedure TForm1.ListFileClick(Sender: TObject);
begin
    //  IĂ
    if (ListFile.ItemIndex <> -1) then
    begin
        SetSelectFile(ListFile.Items[ListFile.ItemIndex]);
    end;
end;

//-----------------------------------------------------------------------------
//  tH_ꗗ`
procedure TForm1.ListFolderDrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);
var
    LListBox: TListBox;
    LItem: String;
var
    LRect: TRect;                   //  `̈
    LDrawFormat: Cardinal;          //  
    LDrawParams: TDrawTextParams;   //  g
    LObject: TObject;
    LPlus: Boolean;
begin
    LListBox := TListBox(Control);
    LItem := ExtractItemName(LListBox.Items[Index]);

    //  TutH_邩ǂ
    LObject := LListBox.Items.Objects[Index];
    LPlus := (LObject <> nil) and (Boolean(LObject));

    //  wihԂ
    LListBox.Canvas.FillRect(Rect);
    //  ACR`
    if (LPlus) then
    begin
        ImageList.Draw(LListBox.Canvas, Rect.Left, Rect.Top, 0);
    end
    else
    begin
        ImageList.Draw(LListBox.Canvas, Rect.Left, Rect.Top, 1);
    end;

    //  `̈
    LRect := Rect;
    //  ݒ
    LDrawFormat := DT_SINGLELINE or DT_VCENTER;
    //  gݒ
    FillChar(LDrawParams, SizeOf(LDrawParams), 0);
    LDrawParams.cbSize := SizeOf(LDrawParams);
    LDrawParams.iTabLength   := 0;
    LDrawParams.iLeftMargin := 20;
    LDrawParams.iRightMargin := 0;
    //  s
    DrawTextEx(LListBox.Canvas.Handle, PChar(LItem), -1,
               LRect, LDrawFormat, @LDrawParams);

    //  ȂƂȂtH[JXg               
    if (odFocused in State) then
    begin
        LListBox.Canvas.DrawFocusRect(Rect);
    end;
end;

//-----------------------------------------------------------------------------
//  t@Cꗗ`
procedure TForm1.ListFileDrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);
var
    LListBox: TListBox;
    LItem: String;
var
    LRect: TRect;                   //  `̈
    LDrawFormat: Cardinal;          //  
    LDrawParams: TDrawTextParams;   //  g
begin
    LListBox := TListBox(Control);
    LItem := ExtractItemName(LListBox.Items[Index]);

    //  wihԂ
    LListBox.Canvas.FillRect(Rect);

    //  ACR`
    ImageList.Draw(LListBox.Canvas, Rect.Left, Rect.Top, 2);

    //  `̈
    LRect := Rect;
    //  ݒ
    LDrawFormat := DT_SINGLELINE or DT_VCENTER;
    //  gݒ
    FillChar(LDrawParams, SizeOf(LDrawParams), 0);
    LDrawParams.cbSize := SizeOf(LDrawParams);
    LDrawParams.iTabLength   := 0;
    LDrawParams.iLeftMargin  := 20;
    LDrawParams.iRightMargin := 0;
    //  s
    DrawTextEx(LListBox.Canvas.Handle, PChar(LItem), -1,
               LRect, LDrawFormat, @LDrawParams);

    //  ȂƂȂtH[JXg               
    if (odFocused in State) then
    begin
        LListBox.Canvas.DrawFocusRect(Rect);
    end;
end;

//-----------------------------------------------------------------------------
//  摜`
procedure TForm1.PaintBoxPaint(Sender: TObject);
var
    LBox: TPaintBox;
    LGPImage: TGPImage;
    LGraphics: TGPGraphics;
    LDestRect: TGPRectF;
    LHeight: Integer;
    LWidth: Integer;
    LHeightRate: Double;
    LWidthRate: Double;
begin
    LBox := TPaintBox(Sender);
    //  wiNA
    FBitmap.Canvas.FillRect(LBox.ClientRect);
    //  t@C̑݃`FbN
    if (FileExists(FSelectFile)) then
    begin
        //  GDI+ NXɓǂݍ܂
        LGraphics := TGPgraphics.Create(FBitmap.Canvas.Handle);
        LGPImage := TGPImage.Create(FSelectFile);
        //  摜t@CȂ
        if (LGPImage.GetType = ImageTypeBitmap) then
        begin
            //  摜
            LHeight := LGPImage.GetHeight;
            //  摜
            LWidth := LGPImage.GetWidth;
            //  c{
            LHeightRate := LBox.Height / LHeight;
            //  {
            LWidthRate := LBox.Width / LWidth;

            //  Ŝ܂
            if (LHeightRate < LWidthRate) then
            begin
                //  {͍ő1{܂
                if (LHeightRate > 1) then
                begin
                    //  
                    LGraphics.DrawImage(LGPImage, 0, 0, LWidth, LHeight);
                end
                //  cς
                else
                begin
                    LDestRect := MakeRect(0, 0, LWidth * LHeightRate, LBox.Height);
                    LGraphics.DrawImage(
                        LGPImage, LDestRect,
                        0, 0,
                        LGPImage.GetWidth,
                        LGPImage.GetHeight,
                        UnitPixel);
                end;
            end
            else
            begin
                //  {͍ő1{܂
                if (LWidthRate > 1) then
                begin
                    //  
                    LGraphics.DrawImage(LGPImage, 0, 0, LWidth, LHeight);
                end
                //  ς
                else
                begin
                LDestRect := MakeRect(0, 0, LBox.Width, LHeight * LWidthRate);
                LGraphics.DrawImage(
                    LGPImage, LDestRect,
                    0, 0,
                    LGPImage.GetWidth,
                    LGPImage.GetHeight,
                    UnitPixel);
                end;
            end;

        end;
        LGPImage.Free();
        LGraphics.Free();
    end;
    //  ʂɓ]
    BitBlt(LBox.Canvas.Handle, 0, 0, LBox.Width, LBox.Height,
            FBitmap.Canvas.Handle, 0, 0, SRCCOPY);
end;

//-----------------------------------------------------------------------------
//  tH_ɓ
procedure TForm1.MenuEnterFolderClick(Sender: TObject);
begin
    if SubFolderExists(FSelectPath) then
    begin
        SetCurrentPath(FSelectPath);
    end
end;

//-----------------------------------------------------------------------------
//  ЂƂ̃tH_
procedure TForm1.MenuLeaveFolderClick(Sender: TObject);
begin
    SetCurrentPath(ExtractFilePath(ExcludeTrailingPathDelimiter(FCurrentPath)));
end;

//-----------------------------------------------------------------------------
//  tH_ꗗtH[JX擾
procedure TForm1.ListFolderEnter(Sender: TObject);
var
    LListBox: TListBox;
begin
    LListBox := TListBox(Sender);
    LListBox.Color := clAqua;

    MenuTrashFolder.Enabled := True;
    MenuTrashFolder.ShortCut := ShortCut(VK_DELETE, []);
end;

//-----------------------------------------------------------------------------
//  tH_ꗗtH[JXr
procedure TForm1.ListFolderExit(Sender: TObject);
begin
    TListBox(Sender).Color := clWindow;

    MenuTrashFolder.Enabled := False;
    MenuTrashFolder.ShortCut := 0;
end;

//-----------------------------------------------------------------------------
//  t@CꗗtH[JX擾
procedure TForm1.ListFileEnter(Sender: TObject);
var
    LListBox: TListBox;
begin
    LListBox := TListBox(Sender);
    LListBox.Color := clAqua;

    MenuTrashFile.Enabled := True;
    MenuTrashFile.ShortCut := ShortCut(VK_DELETE, []);
end;

//-----------------------------------------------------------------------------
//  t@CꗗtH[JXr
procedure TForm1.ListFileExit(Sender: TObject);
begin
    TListBox(Sender).Color := clWindow;

    MenuTrashFile.Enabled := False;
    MenuTrashFile.ShortCut := 0;
end;

//-----------------------------------------------------------------------------
//  S~Ɏ̂Ă
//  http://www2.big.or.jp/~osamu/Delphi/Tips/key.cgi?key=2#0275.txt
function TrashFolder(const APath: String): Boolean;
var
    LText: String;
    LResult: Integer;
    SHF: TSHFileOpStruct;
    LPath: String;
begin
    Result := False;
    LPath := ExcludeTrailingPathDelimiter(APath);

    //  TutH_Ƃ͏Ȃ
    if (SubFolderExists(LPath)) then
    begin
        LText := 'TutH_tH_͎̂|̂ŏ܂B';
        AppMessageBox(LText, Application.Title, MB_OK or MB_ICONINFORMATION);
        Exit;
    end;

    LText := Format('%sS~Ɉڂ܂H', [Quote(ExtractFileName(LPath))]);
    LResult := AppMessageBox(LText, '폜̊mF', MB_YESNO or MB_ICONQUESTION);

    if (LResult <> IDNO) then
    begin
        FillChar(SHF, SizeOf(SHF), 0);
        SHF.Wnd    := Application.Handle;
        SHF.wFunc  := FO_DELETE;
        SHF.pFrom  := PChar(LPath + #0#0);
        SHF.fFlags := FOF_ALLOWUNDO or FOF_NOCONFIRMATION;// or FOF_NOERRORUI;
        LResult := SHFileOperation(SHF);
        Result := (LResult = 0);
    end;
end;

//-----------------------------------------------------------------------------
//  tH_폜
procedure TForm1.MenuTrashFolderClick(Sender: TObject);
var
    LIndex: Integer;
begin
    LIndex := ListFolder.ItemIndex;
    if (TrashFolder(FSelectPath)) then
    begin
        ListFolder.Items.Delete(LIndex);
        if (LIndex >= ListFolder.Items.Count) then
        begin
            Dec(LIndex);
        end;
        ListFolder.ItemIndex := LIndex;
        if (ListFolder.ItemIndex <> -1) then
        begin
            SetSelectPath(ListFolder.Items[ListFolder.ItemIndex]);
        end;
    end;
end;

//-----------------------------------------------------------------------------
//  t@C폜
procedure TForm1.MenuTrashFileClick(Sender: TObject);
var
    LIndex: Integer;
begin
    LIndex := ListFile.ItemIndex;
    if (TrashFolder(FSelectFile)) then
    begin
        ListFile.Items.Delete(LIndex);
        if (LIndex >= ListFile.Items.Count) then
        begin
            Dec(LIndex);
        end;
        ListFile.ItemIndex := LIndex;
        if (ListFile.ItemIndex <> -1) then
        begin
            SetSelectFile(ListFile.Items[ListFile.ItemIndex]);
        end;
    end;
end;

//-----------------------------------------------------------------------------
//  t@Cꗗ
procedure TForm1.MenuRightClick(Sender: TObject);
begin
    ListFile.SetFocus();
end;

//-----------------------------------------------------------------------------
//  tH_ꗗ
procedure TForm1.MenuLeftClick(Sender: TObject);
begin
    ListFolder.SetFocus();
end;

//-----------------------------------------------------------------------------
//  ֘Atꂽr[AŊJ
procedure TForm1.MenuExecuteClick(Sender: TObject);
var
    LGPImage: TGPImage;
    LGraphics: TGPGraphics;
    LIsImage: Boolean;
begin
    LIsImage := False;

    //  t@C̑݃`FbN
    if (FileExists(FSelectFile)) then
    begin
        //  GDI+ NXɓǂݍ܂
        LGraphics := TGPgraphics.Create(FBitmap.Canvas.Handle);
        LGPImage := TGPImage.Create(FSelectFile);
        //  摜t@CȂ
        LIsImage := (LGPImage.GetType = ImageTypeBitmap);
        LGPImage.Free();
        LGraphics.Free();
    end;

    if (LIsImage) then SimpleShellExecute(FSelectFile);
end;

//-----------------------------------------------------------------------------
//  gݍ݂̃V{r[AŊJ
procedure TForm1.MenuFullViewClick(Sender: TObject);
begin
    Form2.Open(FSelectFile);
end;

end.
