unit Viewer;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls;

type
  TForm2 = class(TForm)
    ScrollBox1: TScrollBox;
    PaintBox: TPaintBox;
    procedure PaintBoxPaint(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    FBitmap: TBitmap;
    FFileName: String;
  public
    procedure Open(const AFileName: String);
  end;

var
  Form2: TForm2;

implementation

uses
    GDIPOBJ, GDIPAPI;

{$R *.dfm}

//-----------------------------------------------------------------------------
//  tH[쐬
procedure TForm2.FormCreate(Sender: TObject);
begin
    //  `prbg}bv쐬
    FBitmap := TBitmap.Create();
    FBitmap.Width := Screen.Width;
    FBitmap.Height := Screen.Height;
    PaintBox.ControlStyle := PaintBox.ControlStyle + [csOpaque];
end;

//-----------------------------------------------------------------------------
//  tH[j
procedure TForm2.FormDestroy(Sender: TObject);
begin
    FBitmap.Free();
end;

//-----------------------------------------------------------------------------
procedure TForm2.Open(const AFileName: String);
var
    LGPImage: TGPImage;
    LGraphics: TGPGraphics;
    LHeight: Integer;
    LWidth: Integer;
begin
    FFileName := AFileName;

    //  t@C̑݃`FbN
    if (FileExists(FFileName)) then
    begin
        //  GDI+ NXɓǂݍ܂
        LGraphics := TGPgraphics.Create(FBitmap.Canvas.Handle);
        LGPImage := TGPImage.Create(FFileName);
        //  摜t@CȂ
        if (LGPImage.GetType = ImageTypeBitmap) then
        begin
            //  摜
            LHeight := LGPImage.GetHeight;
            //  摜
            LWidth := LGPImage.GetWidth;
            //  XN[o[
            PaintBox.Height := LHeight;
            PaintBox.Width := LWidth;
        end;
        LGPImage.Free();
        LGraphics.Free();
    end
    else
    begin
        FFileName := '';
    end;

    Self.Caption := FFileName;
    Self.Show();
    PaintBox.Repaint();
end;

//-----------------------------------------------------------------------------
//  摜`
procedure TForm2.PaintBoxPaint(Sender: TObject);
var
    LFileName: String;
    LBox: TPaintBox;
    LGPImage: TGPImage;
    LGraphics: TGPGraphics;
    LHeight: Integer;
    LWidth: Integer;
begin
    LFileName := Self.Caption;

    LBox := TPaintBox(Sender);
    //  wiNA
    FBitmap.Canvas.FillRect(LBox.ClientRect);
    //  t@C̑݃`FbN
    if (FileExists(LFileName)) then
    begin
        //  GDI+ NXɓǂݍ܂
        LGraphics := TGPgraphics.Create(FBitmap.Canvas.Handle);
        LGPImage := TGPImage.Create(LFileName);
        //  摜t@CȂ
        if (LGPImage.GetType = ImageTypeBitmap) then
        begin
            //  摜
            LHeight := LGPImage.GetHeight;
            //  摜
            LWidth := LGPImage.GetWidth;
            //  
            LGraphics.DrawImage(LGPImage, 0, 0, LWidth, LHeight);
        end;
        LGPImage.Free();
        LGraphics.Free();
    end;
    //  ʂɓ]
    BitBlt(LBox.Canvas.Handle, 0, 0, LBox.Width, LBox.Height,
            FBitmap.Canvas.Handle, 0, 0, SRCCOPY);
end;

//-----------------------------------------------------------------------------
procedure TForm2.FormClose(Sender: TObject; var Action: TCloseAction);
begin
    Action := caHide;
end;

end.
